<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ServerStats.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server</a> &gt; <span class="el_source">ServerStats.java</span></div><h1>ServerStats.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server;


/**
 * Basic Server Statistics
 */
public class ServerStats {
    private long packetsSent;
    private long packetsReceived;
    private long maxLatency;
<span class="fc" id="L29">    private long minLatency = Long.MAX_VALUE;</span>
<span class="fc" id="L30">    private long totalLatency = 0;</span>
<span class="fc" id="L31">    private long count = 0;</span>

    private final Provider provider;

    public interface Provider {
        public long getOutstandingRequests();
        public long getLastProcessedZxid();
        public String getState();
        public int getNumAliveConnections();
    }
    
<span class="fc" id="L42">    public ServerStats(Provider provider) {</span>
<span class="fc" id="L43">        this.provider = provider;</span>
<span class="fc" id="L44">    }</span>
    
    // getters
    synchronized public long getMinLatency() {
<span class="fc bfc" id="L48" title="All 2 branches covered.">        return minLatency == Long.MAX_VALUE ? 0 : minLatency;</span>
    }

    synchronized public long getAvgLatency() {
<span class="fc bfc" id="L52" title="All 2 branches covered.">        if (count != 0) {</span>
<span class="fc" id="L53">            return totalLatency / count;</span>
        }
<span class="fc" id="L55">        return 0;</span>
    }

    synchronized public long getMaxLatency() {
<span class="fc" id="L59">        return maxLatency;</span>
    }

    public long getOutstandingRequests() {
<span class="fc" id="L63">        return provider.getOutstandingRequests();</span>
    }
    
    public long getLastProcessedZxid(){
<span class="fc" id="L67">        return provider.getLastProcessedZxid();</span>
    }
    
    synchronized public long getPacketsReceived() {
<span class="fc" id="L71">        return packetsReceived;</span>
    }

    synchronized public long getPacketsSent() {
<span class="fc" id="L75">        return packetsSent;</span>
    }

    public String getServerState() {
<span class="fc" id="L79">        return provider.getState();</span>
    }
    
    /** The number of client connections alive to this server */
    public int getNumAliveClientConnections() {
<span class="fc" id="L84">    	return provider.getNumAliveConnections();</span>
    }

    @Override
    public String toString(){
<span class="fc" id="L89">        StringBuilder sb = new StringBuilder();</span>
<span class="fc" id="L90">        sb.append(&quot;Latency min/avg/max: &quot; + getMinLatency() + &quot;/&quot;</span>
<span class="fc" id="L91">                + getAvgLatency() + &quot;/&quot; + getMaxLatency() + &quot;\n&quot;);</span>
<span class="fc" id="L92">        sb.append(&quot;Received: &quot; + getPacketsReceived() + &quot;\n&quot;);</span>
<span class="fc" id="L93">        sb.append(&quot;Sent: &quot; + getPacketsSent() + &quot;\n&quot;);</span>
<span class="fc" id="L94">        sb.append(&quot;Connections: &quot; + getNumAliveClientConnections() + &quot;\n&quot;);</span>

<span class="pc bpc" id="L96" title="1 of 2 branches missed.">        if (provider != null) {</span>
<span class="fc" id="L97">            sb.append(&quot;Outstanding: &quot; + getOutstandingRequests() + &quot;\n&quot;);</span>
<span class="fc" id="L98">            sb.append(&quot;Zxid: 0x&quot;+ Long.toHexString(getLastProcessedZxid())+ &quot;\n&quot;);</span>
        }
<span class="fc" id="L100">        sb.append(&quot;Mode: &quot; + getServerState() + &quot;\n&quot;);</span>
<span class="fc" id="L101">        return sb.toString();</span>
    }
    // mutators
    synchronized void updateLatency(long requestCreateTime) {
<span class="fc" id="L105">        long latency = System.currentTimeMillis() - requestCreateTime;</span>
<span class="fc" id="L106">        totalLatency += latency;</span>
<span class="fc" id="L107">        count++;</span>
<span class="fc bfc" id="L108" title="All 2 branches covered.">        if (latency &lt; minLatency) {</span>
<span class="fc" id="L109">            minLatency = latency;</span>
        }
<span class="fc bfc" id="L111" title="All 2 branches covered.">        if (latency &gt; maxLatency) {</span>
<span class="fc" id="L112">            maxLatency = latency;</span>
        }
<span class="fc" id="L114">    }</span>
    synchronized public void resetLatency(){
<span class="fc" id="L116">        totalLatency = 0;</span>
<span class="fc" id="L117">        count = 0;</span>
<span class="fc" id="L118">        maxLatency = 0;</span>
<span class="fc" id="L119">        minLatency = Long.MAX_VALUE;</span>
<span class="fc" id="L120">    }</span>
    synchronized public void resetMaxLatency(){
<span class="nc" id="L122">        maxLatency = getMinLatency();</span>
<span class="nc" id="L123">    }</span>
    synchronized public void incrementPacketsReceived() {
<span class="fc" id="L125">        packetsReceived++;</span>
<span class="fc" id="L126">    }</span>
    synchronized public void incrementPacketsSent() {
<span class="fc" id="L128">        packetsSent++;</span>
<span class="fc" id="L129">    }</span>
    synchronized public void resetRequestCounters(){
<span class="fc" id="L131">        packetsReceived = 0;</span>
<span class="fc" id="L132">        packetsSent = 0;</span>
<span class="fc" id="L133">    }</span>
    synchronized public void reset() {
<span class="fc" id="L135">        resetLatency();</span>
<span class="fc" id="L136">        resetRequestCounters();</span>
<span class="fc" id="L137">    }</span>

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>